# Cmput 455 sample code
# Naive minimax without any pruning
# Written by Martin Mueller

from search_basics import INFINITY

def minimaxOR(state):
    if state.endOfGame():
        return state.staticallyEvaluate() 
    best = -INFINITY
    for m in state.legalMoves():
        state.play(m)
        value = minimaxAND(state)
        if value > best:
            best = value
        state.undoMove()
    return best

def minimaxAND(state):
    if state.endOfGame():
        return state.staticallyEvaluate() 
    best = INFINITY
    for m in state.legalMoves():
        state.play(m)
        value = minimaxOR(state)
        if value < best:
            best = value
        state.undoMove()
    return best
